Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# GeomVertexFormat Class Reference

This class defines the physical layout of the vertex data stored within a Geom. More...

Inheritance diagram for GeomVertexFormat:

List of all members.

## Public Member Functions
| GeomVertexFormat ()
| GeomVertexFormat (GeomVertexArrayFormat const array_format)
| GeomVertexFormat (GeomVertexFormat const copy)
int | addArray (GeomVertexArrayFormat const array_format)
| Adds the indicated array definition to the list of arrays included within this vertex format definition.
| alignColumnsForAnimation ()
| Reprocesses the columns in the format to align the C_point and C_vector columns to 16-byte boundaries to allow for the more efficient SSE2 operations (assuming SSE2 is enabled in the build).
| clearArrays ()
| Removes all of the array definitions from the format and starts over.
GeomVertexAnimationSpec const | getAnimation ()
| Returns the GeomVertexAnimationSpec that indicates how this format's vertices are set up for animation.
GeomVertexArrayFormat const | getArray (int array)
| Returns the description of the nth array used by the format.
list | getArrays ()
int | getArrayWith (InternalName const name)
| Returns the index number of the array with the indicated column, or -1 if no arrays contained that name.
int | getArrayWith (int i)
| Returns the index number of the array with the ith column.
GeomVertexColumn const | getColumn (InternalName const name)
| Returns the specification with the indicated name, or NULL if the name is not used.
GeomVertexColumn const | getColumn (int i)
| Returns the ith column of the specification, across all arrays.
list | getColumns ()
InternalName const | getMorphBase (int n)
| Returns the name of the base column that the nth morph modifies.
list | getMorphBases ()
InternalName const | getMorphDelta (int n)
| Returns the name of the column that defines the nth morph.
list | getMorphDeltas ()
InternalName const | getMorphSlider (int n)
| Returns the slider name associated with the nth morph column.
list | getMorphSliders ()
int | getNumArrays ()
| Returns the number of individual arrays required by the format.
int | getNumColumns ()
| Returns the total number of different columns in the specification, across all arrays.
int | getNumMorphs ()
| Returns the number of columns within the format that represent morph deltas.
int | getNumPoints ()
| Returns the number of columns within the format that represent points in space.
int | getNumTexcoords ()
| Returns the number of columns within the format that represent texture coordinates.
int | getNumVectors ()
| Returns the number of columns within the format that represent directional vectors.
InternalName const | getPoint (int n)
| Returns the name of the nth point column.
list | getPoints ()
GeomVertexFormat const | getPostAnimatedFormat ()
| Returns a suitable vertex format for sending the animated vertices to the graphics backend.
InternalName const | getTexcoord (int n)
| Returns the name of the nth texcoord column.
list | getTexcoords ()
GeomVertexFormat const | getUnionFormat (GeomVertexFormat const other)
| Returns a new GeomVertexFormat that includes all of the columns defined in either this GeomVertexFormat or the other one.
InternalName const | getVector (int n)
| Returns the name of the nth vector column.
list | getVectors ()
bool | hasColumn (InternalName const name)
| Returns true if the format has the named column, false otherwise.
| insertArray (int array, GeomVertexArrayFormat const array_format)
| Adds the indicated array definition to the list of arrays at the indicated position.
bool | isRegistered ()
| Returns true if this format has been registered, false if it has not.
| maybeAlignColumnsForAnimation ()
| Calls align_columns_for_animation() if this format's AnimationSpec indicates that it contains animated vertices, and if vertex-animation-align-16 is true.
GeomVertexArrayFormat | modifyArray (int array)
| Returns a modifiable pointer to the indicated array.
GeomVertexFormat | operator= (GeomVertexFormat const copy)
| output (ostream out)
| packColumns ()
| Removes wasted space between columns.
| removeArray (int array)
| Removes the nth array from the format.
| removeColumn (InternalName const name)
| Removes the named column from the format, from whichever array it exists in.
| setAnimation (GeomVertexAnimationSpec const animation)
| Resets the GeomVertexAnimationSpec that indicates how this format's vertices are set up for animation.
| setArray (int array, GeomVertexArrayFormat const format)
| Replaces the definition of the indicated array.
bool | unref ()
| This method overrides ReferenceCount.unref() to unregister the object when its reference count goes to zero.
| write (ostream out)
| write (ostream out, int indent_level)
| writeWithData (ostream out, int indent_level, GeomVertexData const data)
## Static Public Member Functions
static TypeHandle | getClassType ()
static GeomVertexFormat const | getV3 ()
| Returns a standard vertex format with just a 3-component vertex position.
static GeomVertexFormat const | getV3c4 ()
| Returns a standard vertex format with a 4-component color and a 3-component vertex position.
static GeomVertexFormat const | getV3c4t2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair, a 4-component color, and a 3-component vertex position.
static GeomVertexFormat const | getV3cp ()
| Returns a standard vertex format with a packed color and a 3-component vertex position.
static GeomVertexFormat const | getV3cpt2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair, a packed color, and a 3-component vertex position.
static GeomVertexFormat const | getV3n3 ()
| Returns a standard vertex format with a 3-component normal and a 3-component vertex position.
static GeomVertexFormat const | getV3n3c4 ()
| Returns a standard vertex format with a 4-component color, a 3-component normal, and a 3-component vertex position.
static GeomVertexFormat const | getV3n3c4t2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair, a 4-component color, a 3-component normal, and a 3-component vertex position.
static GeomVertexFormat const | getV3n3cp ()
| Returns a standard vertex format with a packed color, a 3-component normal, and a 3-component vertex position.
static GeomVertexFormat const | getV3n3cpt2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair, a packed color, a 3-component normal, and a 3-component vertex position.
static GeomVertexFormat const | getV3n3t2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair, a 3-component normal, and a 3-component vertex position.
static GeomVertexFormat const | getV3t2 ()
| Returns a standard vertex format with a 2-component texture coordinate pair and a 3-component vertex position.
static GeomVertexFormat const | registerFormat (GeomVertexArrayFormat const format)
| This flavor of register_format() implicitly creates a one-array vertex format from the array definition.
static GeomVertexFormat const | registerFormat (GeomVertexFormat const format)
| Adds the indicated format to the registry, if there is not an equivalent format already there; in either case, returns the pointer to the equivalent format now in the registry.

## Detailed Description

This class defines the physical layout of the vertex data stored within a Geom.

The layout consists of a list of named columns, each of which has a numeric type and a size.

The columns are typically interleaved within a single array, but they may also be distributed among multiple different arrays; at the extreme, each column may be alone within its own array (which amounts to a parallel-array definition).

Thus, a GeomVertexFormat is really a list of GeomVertexArrayFormats, each of which contains a list of columns. However, a particular column name should not appear more than once in the format, even between different arrays.

There are a handful of standard pre-defined GeomVertexFormat objects, or you may define your own as needed. You may record any combination of standard and/or user-defined columns in your custom GeomVertexFormat constructions.

## Constructor & Destructor Documentation

GeomVertexFormat | ( |  | ) |

GeomVertexFormat | ( | GeomVertexArrayFormat const | array_format | ) |

GeomVertexFormat | ( | GeomVertexFormat const | copy | ) |

## Member Function Documentation

int addArray | ( | GeomVertexArrayFormat const | array_format | ) |

Adds the indicated array definition to the list of arrays included within this vertex format definition.

The return value is the index number of the new array.

This may not be called once the format has been registered.

alignColumnsForAnimation | ( |  | ) |

Reprocesses the columns in the format to align the C_point and C_vector columns to 16-byte boundaries to allow for the more efficient SSE2 operations (assuming SSE2 is enabled in the build).

Also see maybe_align_columns_for_animation().

clearArrays | ( |  | ) |

Removes all of the array definitions from the format and starts over.

This may not be called once the format has been registered.

GeomVertexAnimationSpec const getAnimation | ( |  | ) |

Returns the GeomVertexAnimationSpec that indicates how this format's vertices are set up for animation.

GeomVertexArrayFormat const getArray | ( | int | array | ) |

Returns the description of the nth array used by the format.

list getArrays | ( |  | ) |

int getArrayWith | ( | InternalName const | name | ) |

Returns the index number of the array with the indicated column, or -1 if no arrays contained that name.

The return value can be passed to get_array_format() to get the format of the array. It may also be passed to GeomVertexData.get_array_data() or get_data() or set_data() to manipulate the actual array data.

This may only be called after the format has been registered.

int getArrayWith | ( | int | i | ) |

Returns the index number of the array with the ith column.

The return value can be passed to get_array_format() to get the format of the array. It may also be passed to GeomVertexData.get_array_data() or get_data() or set_data() to manipulate the actual array data.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedWritableReferenceCount.

GeomVertexColumn const getColumn | ( | InternalName const | name | ) |

Returns the specification with the indicated name, or NULL if the name is not used.

Use get_array_with() to determine which array this column is associated with.

GeomVertexColumn const getColumn | ( | int | i | ) |

Returns the ith column of the specification, across all arrays.

list getColumns | ( |  | ) |

InternalName const getMorphBase | ( | int | n | ) |

Returns the name of the base column that the nth morph modifies.

This column will also be defined within the format, and can be retrieved via get_array_with() and/or get_column().

This may only be called after the format has been registered.

list getMorphBases | ( |  | ) |

InternalName const getMorphDelta | ( | int | n | ) |

Returns the name of the column that defines the nth morph.

This contains the delta offsets that are to be applied to the column defined by get_morph_base(). This column will be defined within the format, and can be retrieved via get_array_with() and/or get_column().

This may only be called after the format has been registered.

list getMorphDeltas | ( |  | ) |

InternalName const getMorphSlider | ( | int | n | ) |

Returns the slider name associated with the nth morph column.

This is the name of the slider that will control the morph, and should be defined within the SliderTable associated with the GeomVertexData.

This may only be called after the format has been registered.

list getMorphSliders | ( |  | ) |

int getNumArrays | ( |  | ) |

Returns the number of individual arrays required by the format.

If the array data is completely interleaved, this will be 1; if it is completely parallel, this will be the same as the number of data types.

int getNumColumns | ( |  | ) |

Returns the total number of different columns in the specification, across all arrays.

int getNumMorphs | ( |  | ) |

Returns the number of columns within the format that represent morph deltas.

This may only be called after the format has been registered.

int getNumPoints | ( |  | ) |

Returns the number of columns within the format that represent points in space.

This may only be called after the format has been registered.

int getNumTexcoords | ( |  | ) |

Returns the number of columns within the format that represent texture coordinates.

This may only be called after the format has been registered.

int getNumVectors | ( |  | ) |

Returns the number of columns within the format that represent directional vectors.

This may only be called after the format has been registered.

InternalName const getPoint | ( | int | n | ) |

Returns the name of the nth point column.

This represents a point in space, which should be transformed by any spatial transform matrix.

This may only be called after the format has been registered.

list getPoints | ( |  | ) |

GeomVertexFormat const getPostAnimatedFormat | ( |  | ) |

Returns a suitable vertex format for sending the animated vertices to the graphics backend.

This is the same format as the source format, with the CPU-animation data elements removed.

This may only be called after the format has been registered. The return value will have been already registered.

InternalName const getTexcoord | ( | int | n | ) |

Returns the name of the nth texcoord column.

This represents a texture coordinate.

This may only be called after the format has been registered.

list getTexcoords | ( |  | ) |

GeomVertexFormat const getUnionFormat | ( | GeomVertexFormat const | other | ) |

Returns a new GeomVertexFormat that includes all of the columns defined in either this GeomVertexFormat or the other one.

If any column is defined in both formats with different sizes (for instance, texcoord2 vs. texcoord3), the new format will include the larger of the two definitions.

This may only be called after both source formats have been registered. The return value will also have been already registered.

static GeomVertexFormat const getV3 | ( |  | ) | `[static]`

Returns a standard vertex format with just a 3-component vertex position.

static GeomVertexFormat const getV3c4 | ( |  | ) | `[static]`

Returns a standard vertex format with a 4-component color and a 3-component vertex position.

static GeomVertexFormat const getV3c4t2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair, a 4-component color, and a 3-component vertex position.

static GeomVertexFormat const getV3cp | ( |  | ) | `[static]`

Returns a standard vertex format with a packed color and a 3-component vertex position.

static GeomVertexFormat const getV3cpt2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair, a packed color, and a 3-component vertex position.

static GeomVertexFormat const getV3n3 | ( |  | ) | `[static]`

Returns a standard vertex format with a 3-component normal and a 3-component vertex position.

static GeomVertexFormat const getV3n3c4 | ( |  | ) | `[static]`

Returns a standard vertex format with a 4-component color, a 3-component normal, and a 3-component vertex position.

static GeomVertexFormat const getV3n3c4t2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair, a 4-component color, a 3-component normal, and a 3-component vertex position.

static GeomVertexFormat const getV3n3cp | ( |  | ) | `[static]`

Returns a standard vertex format with a packed color, a 3-component normal, and a 3-component vertex position.

static GeomVertexFormat const getV3n3cpt2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair, a packed color, a 3-component normal, and a 3-component vertex position.

static GeomVertexFormat const getV3n3t2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair, a 3-component normal, and a 3-component vertex position.

static GeomVertexFormat const getV3t2 | ( |  | ) | `[static]`

Returns a standard vertex format with a 2-component texture coordinate pair and a 3-component vertex position.

InternalName const getVector | ( | int | n | ) |

Returns the name of the nth vector column.

This represents a directional vector, which should be transformed by any spatial transform matrix as a vector.

This may only be called after the format has been registered.

list getVectors | ( |  | ) |

bool hasColumn | ( | InternalName const | name | ) |

Returns true if the format has the named column, false otherwise.

insertArray | ( | int | array,
|  | GeomVertexArrayFormat const | array_format
| ) |  |

Adds the indicated array definition to the list of arrays at the indicated position.

This works just like add_array(), except that you can specify which array index the new array should have.

This may not be called once the format has been registered.

bool isRegistered | ( |  | ) |

Returns true if this format has been registered, false if it has not.

It may not be used for a Geom until it has been registered, but once registered, it may no longer be modified.

maybeAlignColumnsForAnimation | ( |  | ) |

Calls align_columns_for_animation() if this format's AnimationSpec indicates that it contains animated vertices, and if vertex-animation-align-16 is true.

GeomVertexArrayFormat modifyArray | ( | int | array | ) |

Returns a modifiable pointer to the indicated array.

This means duplicating it if it is shared or registered.

This may not be called once the format has been registered.

GeomVertexFormat operator= | ( | GeomVertexFormat const | copy | ) |

output | ( | ostream | out | ) |

packColumns | ( |  | ) |

Removes wasted space between columns.

static GeomVertexFormat const registerFormat | ( | GeomVertexArrayFormat const | format | ) | `[static]`

This flavor of register_format() implicitly creates a one-array vertex format from the array definition.

static GeomVertexFormat const registerFormat | ( | GeomVertexFormat const | format | ) | `[static]`

Adds the indicated format to the registry, if there is not an equivalent format already there; in either case, returns the pointer to the equivalent format now in the registry.

This must be called before a format may be used in a Geom. After this call, you should discard the original pointer you passed in (which may or may not now be invalid) and let its reference count decrement normally; you should use only the returned value from this point on.

removeArray | ( | int | array | ) |

Removes the nth array from the format.

This may not be called once the format has been registered.

removeColumn | ( | InternalName const | name | ) |

Removes the named column from the format, from whichever array it exists in.

If there are other columns remaining in the array, the array is left with a gap where the column used to be; if this was the only column in the array, the array is removed.

This may not be called once the format has been registered.

setAnimation | ( | GeomVertexAnimationSpec const | animation | ) |

Resets the GeomVertexAnimationSpec that indicates how this format's vertices are set up for animation.

You should also, of course, change the columns in the tables accordingly.

This may not be called once the format has been registered.

setArray | ( | int | array,
|  | GeomVertexArrayFormat const | format
| ) |  |

Replaces the definition of the indicated array.

This may not be called once the format has been registered.

bool unref | ( |  | ) |

This method overrides ReferenceCount.unref() to unregister the object when its reference count goes to zero.

Reimplemented from ReferenceCount.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

writeWithData | ( | ostream | out,
|  | int | indent_level,
|  | GeomVertexData const | data
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties